#include <cstdlib>
#include <ctime>
#include "Organism.h"
#include "Cell.h"

//using namespace std;

int const SIZE = 20;

Organism::Organism(){
	size = SIZE;
	cells = new Cell*[size];
	cells[0] = new NormalCell();
	cells[1] = new AbnormalCell();
	current = 1;
    for (int i = current+1; i < size; i++) {
        cells[i] = 0;
    }
}

Organism::Organism(int s){
    if (size < SIZE)
        size = s;
    else 
        size = SIZE;
	cells = new Cell*[size];
	cells[0] = new NormalCell();
	cells[1] = new AbnormalCell();
	current = 1;
    for (int i = current+1; i < size; i++) {
        cells[i] = 0;
    }
}

bool Organism::grow() {
	if (current < size - 1) {
        srand(time(NULL));
		current++;
		cells[current] = cells[rand() % (current - 1)]->divide();
	}
}

void Organism::show(){
	for (int i = 0; i<=current; i++) {
		cells[i]->print();
	}
	
}

Organism::~Organism() {
	for (int i = 0; i<=current; i++) {
		delete cells[i];
	}
	delete [] cells;
}
